#ifndef _sySforce_h
#define _sySforce_h

//-----------------------------------
typedef float float3[3];

class sySparticle {
public:
  int nbParticle;
  float3* position;
  float3* normal;
  float3* velocity;
  float3* force;
  float* mass;
};

class sySsolver {
public:
  bool active;   
  void* id[3]; 
  float time;
};
//-----------------------------------
class sySforce {
public:
  sySforce() { active=1; plan=0; }
  virtual ~sySforce() {}
   
  virtual void init( float t ) {}
  virtual int type() = 0;
  virtual int order() { return 1; }
   
  virtual void compute( sySparticle &p, sySsolver &s ) = 0;
  virtual void constrain( sySparticle &p, sySsolver &s ) {}
   
  bool active;
  int plan;
};
//-----------------------------------
class syXforce {
public:
  syXforce() { force = 0; clf = 0; };
  virtual ~syXforce() {};
  int *clf;
  sySforce *force;
};

#endif
